#line 1 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC12F683/9999Timer/PIC12F_9999Timer.c"






unsigned short i, k, unit=0, ten=0;
unsigned int counter = 0, hundred=0, thousand=0, l;

void SPI_Write_Byte(unsigned short num){
 unsigned short t, Mask, Flag;
  GP5_bit  = 0;
 Mask = 128;
 for (t=0; t<8; t++){
 Flag = num & Mask;
 if(Flag == 0)  GP1_bit  = 0;
 else  GP1_bit  = 1;
  GP5_bit  = 1;
  GP5_bit  = 0;
 Mask = Mask >> 1;
 }
}

void MAX7219_INIT() {

  GP0_bit  = 0;
 SPI_Write_Byte(0x0C);
 SPI_Write_Byte(0x01);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x09);
 SPI_Write_Byte(0x0F);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0A);
 SPI_Write_Byte(0x0F);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0B);
 SPI_Write_Byte(0x03);
  GP0_bit  = 1;


  GP0_bit  = 0;
 SPI_Write_Byte(0x0F);
 SPI_Write_Byte(0x01);
  GP0_bit  = 1;

 Delay_ms(1000);

  GP0_bit  = 0;
 SPI_Write_Byte(0x0F);
 SPI_Write_Byte(0x00);
  GP0_bit  = 1;

}

 void Display_Counter(unsigned int j){
  GP0_bit  = 0;
 SPI_Write_Byte(4);
 SPI_Write_Byte((j/1000)%10);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(3);
 SPI_Write_Byte((j/100)%10);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(2);
 SPI_Write_Byte((j/10)%10);
  GP0_bit  = 1;

  GP0_bit  = 0;
 SPI_Write_Byte(1);
 SPI_Write_Byte(j%10);
  GP0_bit  = 1;
 }

 void update_counter(){
 counter = thousand*1000 + hundred*100 + ten*10 + unit;
 }

 void digit_refresh(unsigned short n){

  GP0_bit  = 0;
 SPI_Write_Byte(0x0B);
 SPI_Write_Byte(n);
  GP0_bit  = 1;
 }

 void delay_debounce(){
 Delay_ms(300);
 }

 void blink_zeros(){
 unsigned short loop;
 for (loop = 0; loop < 5; loop++) {

  GP0_bit  = 0;
 SPI_Write_Byte(0x0C);
 SPI_Write_Byte(0x00);
  GP0_bit  = 1;
 delay_debounce();
 digit_refresh(3);

  GP0_bit  = 0;
 SPI_Write_Byte(0x0C);
 SPI_Write_Byte(0x01);
  GP0_bit  = 1;
 delay_debounce();
 }
 }

 unsigned short time_set_mode = 0, select_digit, TMRON = 0;
 void main() {
 TRISIO=0b00011000;
 GPIO=0x00;
 CMCON0 = 0x07;
 ANSEL = 0x08;
 MAX7219_INIT();
 Display_Counter(counter);
 i = 0;
 PWM1_Init(5000);
 PWM1_Set_Duty(127);
 do{

 if(ADC_Read(3) > 400 && ADC_Read(3) < 700 && TMRON == 0){
 l = 1000;
 while(ADC_Read(3) > 400 && ADC_Read(3) < 700){
 delay_ms(1);
 l--;
 if(l == 0 && counter > 0){
 TMRON = 1;
 PWM1_Start();
 Delay_ms(500);
 PWM1_Stop();
 time_set_mode = 0;
 break;
 }
 }
 if(!TMRON){
 digit_refresh(i);
 select_digit = i;
 i ++;
 if (i >=4) i = 0;
 time_set_mode = 1;
 }
 }

 if(ADC_Read(3) < 100 && time_set_mode == 1){
 delay_debounce();
 switch(select_digit){
 case 0: unit ++;
 if (unit > 9) unit = 0;
 break;
 case 1: ten ++;
 if (ten > 9) ten = 0;
 break;
 case 2: hundred ++;
 if (hundred > 9) hundred = 0;
 break;
 case 3: thousand ++;
 if (thousand > 9) thousand = 0;
 break;
 }
 }

 if(TMRON && counter > 0){
 counter --;
 Display_Counter(counter);
 Delay_ms(1000);

 if(counter == 0) {
 TMRON = 0;
 unit = 0;
 ten = 0;
 hundred = 0;
 thousand = 0;
 i = 0;
 PWM1_Start();
 blink_zeros();
 PWM1_Stop();
 }
 }
 if(!TMRON){
 update_counter();
 Display_Counter(counter);
 }
 }while(1);
}
