
_SPI_Write_Byte:

;PIC12F_9999Timer.c,10 :: 		void SPI_Write_Byte(unsigned short num){
;PIC12F_9999Timer.c,12 :: 		CLK_Pin = 0;
	BCF        GP5_bit+0, 5
;PIC12F_9999Timer.c,13 :: 		Mask = 128;
	MOVLW      128
	MOVWF      R3+0
;PIC12F_9999Timer.c,14 :: 		for (t=0; t<8; t++){
	CLRF       R2+0
L_SPI_Write_Byte0:
	MOVLW      8
	SUBWF      R2+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_SPI_Write_Byte1
;PIC12F_9999Timer.c,15 :: 		Flag = num & Mask;
	MOVF       R3+0, 0
	ANDWF      FARG_SPI_Write_Byte_num+0, 0
	MOVWF      R1+0
;PIC12F_9999Timer.c,16 :: 		if(Flag == 0) MOSI_Pin = 0;
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_SPI_Write_Byte3
	BCF        GP1_bit+0, 1
	GOTO       L_SPI_Write_Byte4
L_SPI_Write_Byte3:
;PIC12F_9999Timer.c,17 :: 		else MOSI_Pin = 1;
	BSF        GP1_bit+0, 1
L_SPI_Write_Byte4:
;PIC12F_9999Timer.c,18 :: 		CLK_Pin = 1;
	BSF        GP5_bit+0, 5
;PIC12F_9999Timer.c,19 :: 		CLK_Pin = 0;
	BCF        GP5_bit+0, 5
;PIC12F_9999Timer.c,20 :: 		Mask = Mask >> 1;
	RRF        R3+0, 1
	BCF        R3+0, 7
;PIC12F_9999Timer.c,14 :: 		for (t=0; t<8; t++){
	INCF       R2+0, 1
;PIC12F_9999Timer.c,21 :: 		}
	GOTO       L_SPI_Write_Byte0
L_SPI_Write_Byte1:
;PIC12F_9999Timer.c,22 :: 		}
L_end_SPI_Write_Byte:
	RETURN
; end of _SPI_Write_Byte

_MAX7219_INIT:

;PIC12F_9999Timer.c,24 :: 		void MAX7219_INIT() {
;PIC12F_9999Timer.c,26 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,27 :: 		SPI_Write_Byte(0x0C);    // Select Shutdown register
	MOVLW      12
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,28 :: 		SPI_Write_Byte(0x01);    // Set D0 bit to return to normal operation
	MOVLW      1
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,29 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,32 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,33 :: 		SPI_Write_Byte(0x09);    // Select Decode Mode register
	MOVLW      9
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,34 :: 		SPI_Write_Byte(0x0F);    // Select BCD mode for digits DIG0-DIG3
	MOVLW      15
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,35 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,38 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,39 :: 		SPI_Write_Byte(0x0A);    // Select Intensity register
	MOVLW      10
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,40 :: 		SPI_Write_Byte(0x0F);    // Set maximum brightness
	MOVLW      15
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,41 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,44 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,45 :: 		SPI_Write_Byte(0x0B);    // Select Scan-Limit register
	MOVLW      11
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,46 :: 		SPI_Write_Byte(0x03);    // Select digits DIG0-DIG3
	MOVLW      3
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,47 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,50 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,51 :: 		SPI_Write_Byte(0x0F);    // Select Display-Test register
	MOVLW      15
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,52 :: 		SPI_Write_Byte(0x01);    // Enable Display-Test
	MOVLW      1
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,53 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,55 :: 		Delay_ms(1000);
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_MAX7219_INIT5:
	DECFSZ     R13+0, 1
	GOTO       L_MAX7219_INIT5
	DECFSZ     R12+0, 1
	GOTO       L_MAX7219_INIT5
	DECFSZ     R11+0, 1
	GOTO       L_MAX7219_INIT5
	NOP
	NOP
;PIC12F_9999Timer.c,57 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,58 :: 		SPI_Write_Byte(0x0F);    // Select Display-Test register
	MOVLW      15
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,59 :: 		SPI_Write_Byte(0x00);    // Disable Display-Test
	CLRF       FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,60 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,62 :: 		}
L_end_MAX7219_INIT:
	RETURN
; end of _MAX7219_INIT

_Display_Counter:

;PIC12F_9999Timer.c,64 :: 		void Display_Counter(unsigned int j){
;PIC12F_9999Timer.c,65 :: 		CS_Pin = 0;                    // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,66 :: 		SPI_Write_Byte(4);             // Send thousands digit
	MOVLW      4
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,67 :: 		SPI_Write_Byte((j/1000)%10);
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	MOVF       FARG_Display_Counter_j+0, 0
	MOVWF      R0+0
	MOVF       FARG_Display_Counter_j+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,68 :: 		CS_Pin = 1;                    // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,70 :: 		CS_Pin = 0;                    // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,71 :: 		SPI_Write_Byte(3);             // Send hundreds digit
	MOVLW      3
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,72 :: 		SPI_Write_Byte((j/100)%10);
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       FARG_Display_Counter_j+0, 0
	MOVWF      R0+0
	MOVF       FARG_Display_Counter_j+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,73 :: 		CS_Pin = 1;                    // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,75 :: 		CS_Pin = 0;                    // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,76 :: 		SPI_Write_Byte(2);             // Send tens digit
	MOVLW      2
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,77 :: 		SPI_Write_Byte((j/10)%10);
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       FARG_Display_Counter_j+0, 0
	MOVWF      R0+0
	MOVF       FARG_Display_Counter_j+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,78 :: 		CS_Pin = 1;                    // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,80 :: 		CS_Pin = 0;                    // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,81 :: 		SPI_Write_Byte(1);             // Send ones digit
	MOVLW      1
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,82 :: 		SPI_Write_Byte(j%10);
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       FARG_Display_Counter_j+0, 0
	MOVWF      R0+0
	MOVF       FARG_Display_Counter_j+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,83 :: 		CS_Pin = 1;                    // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,84 :: 		}
L_end_Display_Counter:
	RETURN
; end of _Display_Counter

_update_counter:

;PIC12F_9999Timer.c,86 :: 		void update_counter(){
;PIC12F_9999Timer.c,87 :: 		counter = thousand*1000 + hundred*100 + ten*10 + unit;
	MOVF       _thousand+0, 0
	MOVWF      R0+0
	MOVF       _thousand+1, 0
	MOVWF      R0+1
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__update_counter+0
	MOVF       R0+1, 0
	MOVWF      FLOC__update_counter+1
	MOVF       _hundred+0, 0
	MOVWF      R0+0
	MOVF       _hundred+1, 0
	MOVWF      R0+1
	MOVLW      100
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__update_counter+0, 0
	MOVWF      _counter+0
	MOVF       FLOC__update_counter+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      _counter+1
	MOVF       _ten+0, 0
	MOVWF      R0+0
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDWF      _counter+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      _counter+1, 1
	MOVF       _unit+0, 0
	ADDWF      _counter+0, 1
	BTFSC      STATUS+0, 0
	INCF       _counter+1, 1
;PIC12F_9999Timer.c,88 :: 		}
L_end_update_counter:
	RETURN
; end of _update_counter

_digit_refresh:

;PIC12F_9999Timer.c,90 :: 		void digit_refresh(unsigned short n){
;PIC12F_9999Timer.c,92 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,93 :: 		SPI_Write_Byte(0x0B);    // Select Scan-Limit register
	MOVLW      11
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,94 :: 		SPI_Write_Byte(n);    // Select digits DIG0-DIG3
	MOVF       FARG_digit_refresh_n+0, 0
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,95 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,96 :: 		}
L_end_digit_refresh:
	RETURN
; end of _digit_refresh

_delay_debounce:

;PIC12F_9999Timer.c,98 :: 		void delay_debounce(){
;PIC12F_9999Timer.c,99 :: 		Delay_ms(300);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L_delay_debounce6:
	DECFSZ     R13+0, 1
	GOTO       L_delay_debounce6
	DECFSZ     R12+0, 1
	GOTO       L_delay_debounce6
	DECFSZ     R11+0, 1
	GOTO       L_delay_debounce6
;PIC12F_9999Timer.c,100 :: 		}
L_end_delay_debounce:
	RETURN
; end of _delay_debounce

_blink_zeros:

;PIC12F_9999Timer.c,102 :: 		void blink_zeros(){
;PIC12F_9999Timer.c,104 :: 		for (loop = 0; loop < 5; loop++) {
	CLRF       blink_zeros_loop_L0+0
L_blink_zeros7:
	MOVLW      5
	SUBWF      blink_zeros_loop_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_blink_zeros8
;PIC12F_9999Timer.c,106 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,107 :: 		SPI_Write_Byte(0x0C);    // Select Shutdown register
	MOVLW      12
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,108 :: 		SPI_Write_Byte(0x00);    // Set D0 bit to return to normal operation
	CLRF       FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,109 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,110 :: 		delay_debounce();
	CALL       _delay_debounce+0
;PIC12F_9999Timer.c,111 :: 		digit_refresh(3);
	MOVLW      3
	MOVWF      FARG_digit_refresh_n+0
	CALL       _digit_refresh+0
;PIC12F_9999Timer.c,113 :: 		CS_Pin = 0;              // CS pin is pulled LOW
	BCF        GP0_bit+0, 0
;PIC12F_9999Timer.c,114 :: 		SPI_Write_Byte(0x0C);    // Select Shutdown register
	MOVLW      12
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,115 :: 		SPI_Write_Byte(0x01);    // Set D0 bit to return to normal operation
	MOVLW      1
	MOVWF      FARG_SPI_Write_Byte_num+0
	CALL       _SPI_Write_Byte+0
;PIC12F_9999Timer.c,116 :: 		CS_Pin = 1;              // CS pin is pulled HIGH
	BSF        GP0_bit+0, 0
;PIC12F_9999Timer.c,117 :: 		delay_debounce();
	CALL       _delay_debounce+0
;PIC12F_9999Timer.c,104 :: 		for (loop = 0; loop < 5; loop++) {
	INCF       blink_zeros_loop_L0+0, 1
;PIC12F_9999Timer.c,118 :: 		}
	GOTO       L_blink_zeros7
L_blink_zeros8:
;PIC12F_9999Timer.c,119 :: 		}
L_end_blink_zeros:
	RETURN
; end of _blink_zeros

_main:

;PIC12F_9999Timer.c,122 :: 		void main() {
;PIC12F_9999Timer.c,123 :: 		TRISIO=0b00011000;     // GP3, GP4 are input
	MOVLW      24
	MOVWF      TRISIO+0
;PIC12F_9999Timer.c,124 :: 		GPIO=0x00;             // All O/Ps zero
	CLRF       GPIO+0
;PIC12F_9999Timer.c,125 :: 		CMCON0 = 0x07;
	MOVLW      7
	MOVWF      CMCON0+0
;PIC12F_9999Timer.c,126 :: 		ANSEL = 0x08;            // AN3 active
	MOVLW      8
	MOVWF      ANSEL+0
;PIC12F_9999Timer.c,127 :: 		MAX7219_INIT();              // initialize  max7219
	CALL       _MAX7219_INIT+0
;PIC12F_9999Timer.c,128 :: 		Display_Counter(counter);
	MOVF       _counter+0, 0
	MOVWF      FARG_Display_Counter_j+0
	MOVF       _counter+1, 0
	MOVWF      FARG_Display_Counter_j+1
	CALL       _Display_Counter+0
;PIC12F_9999Timer.c,129 :: 		i = 0;
	CLRF       _i+0
;PIC12F_9999Timer.c,130 :: 		PWM1_Init(5000); // PWM module initialization (5KHz)
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      199
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;PIC12F_9999Timer.c,131 :: 		PWM1_Set_Duty(127);
	MOVLW      127
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;PIC12F_9999Timer.c,132 :: 		do{
L_main10:
;PIC12F_9999Timer.c,134 :: 		if(ADC_Read(3) > 400 && ADC_Read(3) < 700 && TMRON == 0){
	MOVLW      3
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+1, 0
	SUBLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main59
	MOVF       R0+0, 0
	SUBLW      144
L__main59:
	BTFSC      STATUS+0, 0
	GOTO       L_main15
	MOVLW      3
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVLW      2
	SUBWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main60
	MOVLW      188
	SUBWF      R0+0, 0
L__main60:
	BTFSC      STATUS+0, 0
	GOTO       L_main15
	MOVF       _TMRON+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main15
L__main50:
;PIC12F_9999Timer.c,135 :: 		l = 1000;
	MOVLW      232
	MOVWF      _l+0
	MOVLW      3
	MOVWF      _l+1
;PIC12F_9999Timer.c,136 :: 		while(ADC_Read(3) > 400 && ADC_Read(3) < 700){
L_main16:
	MOVLW      3
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+1, 0
	SUBLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main61
	MOVF       R0+0, 0
	SUBLW      144
L__main61:
	BTFSC      STATUS+0, 0
	GOTO       L_main17
	MOVLW      3
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVLW      2
	SUBWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main62
	MOVLW      188
	SUBWF      R0+0, 0
L__main62:
	BTFSC      STATUS+0, 0
	GOTO       L_main17
L__main49:
;PIC12F_9999Timer.c,137 :: 		delay_ms(1);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_main20:
	DECFSZ     R13+0, 1
	GOTO       L_main20
	DECFSZ     R12+0, 1
	GOTO       L_main20
;PIC12F_9999Timer.c,138 :: 		l--;
	MOVLW      1
	SUBWF      _l+0, 1
	BTFSS      STATUS+0, 0
	DECF       _l+1, 1
;PIC12F_9999Timer.c,139 :: 		if(l == 0 && counter > 0){
	MOVLW      0
	XORWF      _l+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main63
	MOVLW      0
	XORWF      _l+0, 0
L__main63:
	BTFSS      STATUS+0, 2
	GOTO       L_main23
	MOVF       _counter+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main64
	MOVF       _counter+0, 0
	SUBLW      0
L__main64:
	BTFSC      STATUS+0, 0
	GOTO       L_main23
L__main48:
;PIC12F_9999Timer.c,140 :: 		TMRON = 1;
	MOVLW      1
	MOVWF      _TMRON+0
;PIC12F_9999Timer.c,141 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;PIC12F_9999Timer.c,142 :: 		Delay_ms(500);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main24:
	DECFSZ     R13+0, 1
	GOTO       L_main24
	DECFSZ     R12+0, 1
	GOTO       L_main24
	DECFSZ     R11+0, 1
	GOTO       L_main24
	NOP
	NOP
;PIC12F_9999Timer.c,143 :: 		PWM1_Stop();
	CALL       _PWM1_Stop+0
;PIC12F_9999Timer.c,144 :: 		time_set_mode = 0;
	CLRF       _time_set_mode+0
;PIC12F_9999Timer.c,145 :: 		break;
	GOTO       L_main17
;PIC12F_9999Timer.c,146 :: 		}
L_main23:
;PIC12F_9999Timer.c,147 :: 		}
	GOTO       L_main16
L_main17:
;PIC12F_9999Timer.c,148 :: 		if(!TMRON){
	MOVF       _TMRON+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_main25
;PIC12F_9999Timer.c,149 :: 		digit_refresh(i);
	MOVF       _i+0, 0
	MOVWF      FARG_digit_refresh_n+0
	CALL       _digit_refresh+0
;PIC12F_9999Timer.c,150 :: 		select_digit = i;
	MOVF       _i+0, 0
	MOVWF      _select_digit+0
;PIC12F_9999Timer.c,151 :: 		i ++;
	INCF       _i+0, 1
;PIC12F_9999Timer.c,152 :: 		if (i >=4) i = 0;
	MOVLW      4
	SUBWF      _i+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_main26
	CLRF       _i+0
L_main26:
;PIC12F_9999Timer.c,153 :: 		time_set_mode = 1;
	MOVLW      1
	MOVWF      _time_set_mode+0
;PIC12F_9999Timer.c,154 :: 		}
L_main25:
;PIC12F_9999Timer.c,155 :: 		}
L_main15:
;PIC12F_9999Timer.c,157 :: 		if(ADC_Read(3) < 100 && time_set_mode == 1){
	MOVLW      3
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVLW      0
	SUBWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main65
	MOVLW      100
	SUBWF      R0+0, 0
L__main65:
	BTFSC      STATUS+0, 0
	GOTO       L_main29
	MOVF       _time_set_mode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main29
L__main47:
;PIC12F_9999Timer.c,158 :: 		delay_debounce();
	CALL       _delay_debounce+0
;PIC12F_9999Timer.c,159 :: 		switch(select_digit){
	GOTO       L_main30
;PIC12F_9999Timer.c,160 :: 		case 0: unit ++;
L_main32:
	INCF       _unit+0, 1
;PIC12F_9999Timer.c,161 :: 		if (unit > 9) unit = 0;
	MOVF       _unit+0, 0
	SUBLW      9
	BTFSC      STATUS+0, 0
	GOTO       L_main33
	CLRF       _unit+0
L_main33:
;PIC12F_9999Timer.c,162 :: 		break;
	GOTO       L_main31
;PIC12F_9999Timer.c,163 :: 		case 1: ten ++;
L_main34:
	INCF       _ten+0, 1
;PIC12F_9999Timer.c,164 :: 		if (ten > 9) ten = 0;
	MOVF       _ten+0, 0
	SUBLW      9
	BTFSC      STATUS+0, 0
	GOTO       L_main35
	CLRF       _ten+0
L_main35:
;PIC12F_9999Timer.c,165 :: 		break;
	GOTO       L_main31
;PIC12F_9999Timer.c,166 :: 		case 2: hundred ++;
L_main36:
	INCF       _hundred+0, 1
	BTFSC      STATUS+0, 2
	INCF       _hundred+1, 1
;PIC12F_9999Timer.c,167 :: 		if (hundred > 9) hundred = 0;
	MOVF       _hundred+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main66
	MOVF       _hundred+0, 0
	SUBLW      9
L__main66:
	BTFSC      STATUS+0, 0
	GOTO       L_main37
	CLRF       _hundred+0
	CLRF       _hundred+1
L_main37:
;PIC12F_9999Timer.c,168 :: 		break;
	GOTO       L_main31
;PIC12F_9999Timer.c,169 :: 		case 3: thousand ++;
L_main38:
	INCF       _thousand+0, 1
	BTFSC      STATUS+0, 2
	INCF       _thousand+1, 1
;PIC12F_9999Timer.c,170 :: 		if (thousand > 9) thousand = 0;
	MOVF       _thousand+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main67
	MOVF       _thousand+0, 0
	SUBLW      9
L__main67:
	BTFSC      STATUS+0, 0
	GOTO       L_main39
	CLRF       _thousand+0
	CLRF       _thousand+1
L_main39:
;PIC12F_9999Timer.c,171 :: 		break;
	GOTO       L_main31
;PIC12F_9999Timer.c,172 :: 		}
L_main30:
	MOVF       _select_digit+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_main32
	MOVF       _select_digit+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_main34
	MOVF       _select_digit+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_main36
	MOVF       _select_digit+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_main38
L_main31:
;PIC12F_9999Timer.c,173 :: 		}
L_main29:
;PIC12F_9999Timer.c,175 :: 		if(TMRON && counter > 0){
	MOVF       _TMRON+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main42
	MOVF       _counter+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main68
	MOVF       _counter+0, 0
	SUBLW      0
L__main68:
	BTFSC      STATUS+0, 0
	GOTO       L_main42
L__main46:
;PIC12F_9999Timer.c,176 :: 		counter --;
	MOVLW      1
	SUBWF      _counter+0, 1
	BTFSS      STATUS+0, 0
	DECF       _counter+1, 1
;PIC12F_9999Timer.c,177 :: 		Display_Counter(counter);
	MOVF       _counter+0, 0
	MOVWF      FARG_Display_Counter_j+0
	MOVF       _counter+1, 0
	MOVWF      FARG_Display_Counter_j+1
	CALL       _Display_Counter+0
;PIC12F_9999Timer.c,178 :: 		Delay_ms(1000);
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main43:
	DECFSZ     R13+0, 1
	GOTO       L_main43
	DECFSZ     R12+0, 1
	GOTO       L_main43
	DECFSZ     R11+0, 1
	GOTO       L_main43
	NOP
	NOP
;PIC12F_9999Timer.c,180 :: 		if(counter == 0) {
	MOVLW      0
	XORWF      _counter+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main69
	MOVLW      0
	XORWF      _counter+0, 0
L__main69:
	BTFSS      STATUS+0, 2
	GOTO       L_main44
;PIC12F_9999Timer.c,181 :: 		TMRON = 0;
	CLRF       _TMRON+0
;PIC12F_9999Timer.c,182 :: 		unit = 0;
	CLRF       _unit+0
;PIC12F_9999Timer.c,183 :: 		ten = 0;
	CLRF       _ten+0
;PIC12F_9999Timer.c,184 :: 		hundred = 0;
	CLRF       _hundred+0
	CLRF       _hundred+1
;PIC12F_9999Timer.c,185 :: 		thousand = 0;
	CLRF       _thousand+0
	CLRF       _thousand+1
;PIC12F_9999Timer.c,186 :: 		i = 0;
	CLRF       _i+0
;PIC12F_9999Timer.c,187 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;PIC12F_9999Timer.c,188 :: 		blink_zeros();
	CALL       _blink_zeros+0
;PIC12F_9999Timer.c,189 :: 		PWM1_Stop();
	CALL       _PWM1_Stop+0
;PIC12F_9999Timer.c,190 :: 		}
L_main44:
;PIC12F_9999Timer.c,191 :: 		}
L_main42:
;PIC12F_9999Timer.c,192 :: 		if(!TMRON){
	MOVF       _TMRON+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L_main45
;PIC12F_9999Timer.c,193 :: 		update_counter();
	CALL       _update_counter+0
;PIC12F_9999Timer.c,194 :: 		Display_Counter(counter);
	MOVF       _counter+0, 0
	MOVWF      FARG_Display_Counter_j+0
	MOVF       _counter+1, 0
	MOVWF      FARG_Display_Counter_j+1
	CALL       _Display_Counter+0
;PIC12F_9999Timer.c,195 :: 		}
L_main45:
;PIC12F_9999Timer.c,196 :: 		}while(1);
	GOTO       L_main10
;PIC12F_9999Timer.c,197 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
